/*
 * name Dice.pde
 * date Wed Feb 27 22:07:29 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int    LedRed1 =   2;  // Led:Red
int    LedRed2 =   3;  // Led:Red
int    LedRed3 =   4;  // Led:Red
int    LedRed4 =   5;  // Led:Red
int    LedRed5 =   6;  // Led:Red
int    LedRed6 =   7;  // Led:Red
int    LedRed7 =   8;  // Led:Red
int     Button =   9;  // Switch:Push
int        Spk =  10;  // Speaker:

int spots = 1;    // サイコロの目

void setup() {
  initComponents();
  // 電子サイコロです。ボタンを押すとサイコロの目が変わります。
  // initialize
     pinMode(LedRed1, OUTPUT);  // Led:Red
     pinMode(LedRed2, OUTPUT);  // Led:Red
     pinMode(LedRed3, OUTPUT);  // Led:Red
     pinMode(LedRed4, OUTPUT);  // Led:Red
     pinMode(LedRed5, OUTPUT);  // Led:Red
     pinMode(LedRed6, OUTPUT);  // Led:Red
     pinMode(LedRed7, OUTPUT);  // Led:Red
     pinMode(Button,  INPUT );  // Switch:Push
     pinMode(Spk,     OUTPUT);  // Speaker:
}

void loop() {
  
  int buttonState = digitalRead(Button);
  
  if (buttonState == HIGH) {
    dispDice(spots);
    spots++;
    if (spots > 6) spots = 1;
    tone(Spk, 880,  50); // 880Hz 0.05 秒
    delay(500);
  }
/*  
  dispDice(1); delay(500);
  dispDice(2); delay(500);
  dispDice(3); delay(500);
  dispDice(4); delay(500);
  dispDice(5); delay(500);
  dispDice(6); delay(500);
  */
}

void dispDice(int n) {
  switch (n) {
    case  1 : setLed(HIGH, LOW , LOW , LOW , LOW , LOW , LOW ); break;
    case  2 : setLed(LOW , LOW , LOW , HIGH, HIGH, LOW , LOW ); break;
    case  3 : setLed(HIGH, LOW , LOW , HIGH, HIGH, LOW , LOW ); break;
    case  4 : setLed(LOW , HIGH, LOW , HIGH, HIGH, LOW , HIGH); break;
    case  5 : setLed(HIGH, HIGH, LOW , HIGH, HIGH, LOW , HIGH); break;
    case  6 : setLed(LOW , HIGH, HIGH, HIGH, HIGH, HIGH, HIGH); break;
  }
}

void setLed(int spot1, int spot2, int spot3, int spot4, int spot5, int spot6, int spot7 ) {
   digitalWrite(LedRed1, spot1);
   digitalWrite(LedRed2, spot2);
   digitalWrite(LedRed3, spot3);
   digitalWrite(LedRed4, spot4);
   digitalWrite(LedRed5, spot5);
   digitalWrite(LedRed6, spot6);
   digitalWrite(LedRed7, spot7);  
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 9 : value = switch9.isState(); break;
    }
    return value;
}
// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 2 : led2.setState(value); break;
        case 3 : led3.setState(value); break;
        case 4 : led4.setState(value); break;
        case 5 : led5.setState(value); break;
        case 6 : led6.setState(value); break;
        case 7 : led7.setState(value); break;
        case 8 : led8.setState(value); break;
    }
}
// Speakerで使用する関数群

void tone(int pin, int frequency) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  speaker10.setFrequency(frequency);
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
}

void tone(int pin, int frequency, long duration) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
  TimerTaskAudioStop timerTask = new TimerTaskAudioStop(); //タイマータスクインスタンス作成
  //タイマー開始
  DelayTimer.schedule(timerTask, duration);
}

void noTone() {
  ToneFlag = 0;
  speaker10.setFrequency(0);
  auOut.mute();
  auOut.noSound();
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                      led2 = new Led(2 , "red",  120,  144);
                      led3 = new Led(3 , "red",    0,    0);
                      led4 = new Led(4 , "red",    0,  144);
                      led5 = new Led(5 , "red",    0,  288);
                      led6 = new Led(6 , "red",  240,    0);
                      led7 = new Led(7 , "red",  240,  144);
                      led8 = new Led(8 , "red",  240,  288);
                   switch9 = new Switch(9 , "Push9",  120,  432);
                 speaker10 = new Speaker(10 , "speaker10",  240,  432);
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill(15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Led led2;
private Led led3;
private Led led4;
private Led led5;
private Led led6;
private Led led7;
private Led led8;
private Switch switch9;
private Speaker speaker10;

// End of variables declaration//GEN-END:variables

