/*
 * name Many7Seg.pde
 * date Sun Feb 24 17:40:54 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int  S19 =  19;  // SevenSegmentDisplay
int  S18 =  18;  // SevenSegmentDisplay

void setup() {
  // 複数の7SegLED表示テスト
  // 実際のArduinoでは，パーツを1個増やすだけでも手間がかかりますが，
  // Emuduinoなら，簡単に増やしたり，減らしたりできます。
  // 数と配置はEmuduinoDesignerで7SegLEDを設定する際に，Opeionの欄で指定してください。
  // m:1行に表示する7SegLEDの数
  // n:7SegLEDの行数
  // 例
  // 8,1 :7SegLED 8個を1行，合計 8個を表示する。
  // 6,2 :7SegLED 6個を2行，合計12個を表示する。
  // 4,3 :7SegLED 4個を3行，合計12個を表示する。
  initComponents();
}

void loop() {
  int c = 8;
  int r = 3;
  int i = (int)random(0, (c * r));
  int value = (int)random(0, 15);
  disp7SEG1(i, value);
  delay(50);               // wait for a second
  print(i);
  print(":");
  println(value);

// digitalWrite(13, HIGH);    // turn the LED on (HIGH is the voltage level)
// delay(1000);               // wait for a second
// digitalWrite(13, LOW);     // turn the LED off by making the voltage LOW
// delay(1000);               // wait for a second
}

void draw() {

  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// Seven Segment Display
void disp7SEG1(int n, int value) {
  // n     : 7seg number  0 - 23
  // value : 0 - 15
  switch (n) {
    case   0 : ssd1[ 0].setValue(value); break;
    case   1 : ssd1[ 1].setValue(value); break;
    case   2 : ssd1[ 2].setValue(value); break;
    case   3 : ssd1[ 3].setValue(value); break;
    case   4 : ssd1[ 4].setValue(value); break;
    case   5 : ssd1[ 5].setValue(value); break;
    case   6 : ssd1[ 6].setValue(value); break;
    case   7 : ssd1[ 7].setValue(value); break;
    case   8 : ssd1[ 8].setValue(value); break;
    case   9 : ssd1[ 9].setValue(value); break;
    case  10 : ssd1[10].setValue(value); break;
    case  11 : ssd1[11].setValue(value); break;
    case  12 : ssd1[12].setValue(value); break;
    case  13 : ssd1[13].setValue(value); break;
    case  14 : ssd1[14].setValue(value); break;
    case  15 : ssd1[15].setValue(value); break;
    case  16 : ssd1[16].setValue(value); break;
    case  17 : ssd1[17].setValue(value); break;
    case  18 : ssd1[18].setValue(value); break;
    case  19 : ssd1[19].setValue(value); break;
    case  20 : ssd1[20].setValue(value); break;
    case  21 : ssd1[21].setValue(value); break;
    case  22 : ssd1[22].setValue(value); break;
    case  23 : ssd1[23].setValue(value); break;
  }
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
  int max = 24;
ssd1 = new SevenSegmentDisplay[max];
int i = 0;
for (int r = 0; r < 3;    r++) {
  for (int c = 0; c < 8; c++) {
    String ssd_num = "SSD " + Integer.valueOf(i).toString();
    ssd1[i] = new SevenSegmentDisplay(i , ssd_num, 16 + c * 144, 16 + r * 264);
    i++;
  }
}

  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill(15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

// private static final int A0     = 0x0;
// private static final int A1     = 0x1;
// private static final int A2     = 0x2;
// private static final int A3     = 0x3;
// private static final int A4     = 0x4;
// private static final int A5     = 0x5;
// private static final int A6     = 0x6;
// private static final int A7     = 0x7;
// private static final int A8     = 0x8;
// private static final int A9     = 0x9;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private SevenSegmentDisplay[] ssd1;


// End of variables declaration//GEN-END:variables


